// File RTCG2D.cs --- generating and calling a method with argument and result
// sestoft@dina.kvl.dk * 2003-03-18, 2005-04-12

using System;
using System.Reflection;
using System.Reflection.Emit;

//  The code below generates a method MyMethod that might have been  
//  declared as follows in C#:
//
//    public static double MyMethod(double x) { 
//      Console.WriteLine("MyMethod() was called");
//      return x + 2.1;
//    }

class RTCG2 {
  public static void Main(String [] args) {
    // Build method: public static double MyMethod(double x) { ... }
    DynamicMethod methodBuilder =
      new DynamicMethod("MyMethod",			// Method name
                        typeof(double),                 // Return type
                        new Type[] { typeof(double) },  // Arg. types
                        typeof(String).Module);         // Module

    // Obtain an IL generator to build the method body
    ILGenerator ilg = methodBuilder.GetILGenerator();
    ilg.EmitWriteLine("MyMethod() was called");
    ilg.Emit(OpCodes.Ldarg_0);
    ilg.Emit(OpCodes.Ldc_R8, 2.1);
    ilg.Emit(OpCodes.Add);
    ilg.Emit(OpCodes.Ret);  
    
    double res;

    // Obtain a delegate referring to the method, and call it:
    D2D mm = (D2D)methodBuilder.CreateDelegate(typeof(D2D));
    res = mm(7);
    Console.WriteLine(res);
  }

  public delegate double D2D(double x);
}
